/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o
{
	/// <exclude></exclude>
	public abstract class Config4Abstract
	{
		protected com.db4o.foundation.KeySpecHashtable4 _config;

		private static readonly com.db4o.foundation.KeySpec CASCADE_ON_ACTIVATE = new com.db4o.foundation.KeySpec
			(com.db4o.YapConst.DEFAULT);

		private static readonly com.db4o.foundation.KeySpec CASCADE_ON_DELETE = new com.db4o.foundation.KeySpec
			(com.db4o.YapConst.DEFAULT);

		private static readonly com.db4o.foundation.KeySpec CASCADE_ON_UPDATE = new com.db4o.foundation.KeySpec
			(com.db4o.YapConst.DEFAULT);

		private static readonly com.db4o.foundation.KeySpec NAME = new com.db4o.foundation.KeySpec
			(null);

		public Config4Abstract() : this(new com.db4o.foundation.KeySpecHashtable4(10))
		{
		}

		protected Config4Abstract(com.db4o.foundation.KeySpecHashtable4 config)
		{
			_config = (com.db4o.foundation.KeySpecHashtable4)config.DeepClone(this);
		}

		public virtual void CascadeOnActivate(bool flag)
		{
			PutThreeValued(CASCADE_ON_ACTIVATE, flag);
		}

		public virtual void CascadeOnDelete(bool flag)
		{
			PutThreeValued(CASCADE_ON_DELETE, flag);
		}

		public virtual void CascadeOnUpdate(bool flag)
		{
			PutThreeValued(CASCADE_ON_UPDATE, flag);
		}

		protected virtual void PutThreeValued(com.db4o.foundation.KeySpec spec, bool flag
			)
		{
			_config.Put(spec, flag ? com.db4o.YapConst.YES : com.db4o.YapConst.NO);
		}

		public virtual int CascadeOnActivate()
		{
			return Cascade(CASCADE_ON_ACTIVATE);
		}

		public virtual int CascadeOnDelete()
		{
			return Cascade(CASCADE_ON_DELETE);
		}

		public virtual int CascadeOnUpdate()
		{
			return Cascade(CASCADE_ON_UPDATE);
		}

		private int Cascade(com.db4o.foundation.KeySpec spec)
		{
			return _config.GetAsInt(spec);
		}

		internal abstract string ClassName();

		public override bool Equals(object obj)
		{
			return GetName().Equals(((com.db4o.Config4Abstract)obj).GetName());
		}

		public virtual string GetName()
		{
			return _config.GetAsString(NAME);
		}

		protected virtual void SetName(string name)
		{
			_config.Put(NAME, name);
		}
	}
}
