/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o
{
	internal sealed class MReadBytes : com.db4o.MsgD
	{
		internal sealed override com.db4o.YapWriter GetByteLoad()
		{
			int address = this._payLoad.ReadInt();
			int length = this._payLoad.GetLength() - (com.db4o.YapConst.YAPINT_LENGTH);
			this._payLoad.RemoveFirstBytes(com.db4o.YapConst.YAPINT_LENGTH);
			this._payLoad.UseSlot(address, length);
			return this._payLoad;
		}

		internal sealed override com.db4o.MsgD GetWriter(com.db4o.YapWriter bytes)
		{
			com.db4o.MsgD message = this.GetWriterForLength(bytes.GetTransaction(), bytes.GetLength
				() + com.db4o.YapConst.YAPINT_LENGTH);
			message._payLoad.WriteInt(bytes.GetAddress());
			message._payLoad.Append(bytes._buffer);
			return message;
		}

		internal sealed override bool ProcessMessageAtServer(com.db4o.foundation.network.YapSocket
			 sock)
		{
			com.db4o.YapStream stream = GetStream();
			int address = this.ReadInt();
			int length = this.ReadInt();
			lock (stream.i_lock)
			{
				com.db4o.YapWriter bytes = new com.db4o.YapWriter(this.GetTransaction(), address, 
					length);
				try
				{
					stream.ReadBytes(bytes._buffer, address, length);
					GetWriter(bytes).Write(stream, sock);
				}
				catch (System.Exception e)
				{
					com.db4o.Msg.NULL.Write(stream, sock);
				}
			}
			return true;
		}
	}
}
