/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o
{
	internal sealed class YDate : com.db4o.YLong
	{
		private static readonly j4o.util.Date PROTO = new j4o.util.Date(0);

		public YDate(com.db4o.YapStream stream) : base(stream)
		{
		}

		public override object Coerce(com.db4o.reflect.ReflectClass claxx, object obj)
		{
			return CanHold(claxx) ? obj : com.db4o.foundation.No4.INSTANCE;
		}

		public override void CopyValue(object a_from, object a_to)
		{
			try
			{
				((j4o.util.Date)a_to).SetTime(((j4o.util.Date)a_from).GetTime());
			}
			catch (System.Exception e)
			{
			}
		}

		public override object DefaultValue()
		{
			return PROTO;
		}

		public override int GetID()
		{
			return 10;
		}

		public override bool IndexNullHandling()
		{
			return true;
		}

		protected override j4o.lang.Class PrimitiveJavaClass()
		{
			return null;
		}

		internal override object PrimitiveNull()
		{
			return null;
		}

		internal override object Read1(com.db4o.YapReader a_bytes)
		{
			return new j4o.util.Date(ReadLong(a_bytes));
		}

		public override void Write(object a_object, com.db4o.YapReader a_bytes)
		{
			if (a_object == null)
			{
				a_object = new j4o.util.Date(0);
			}
			WriteLong(((j4o.util.Date)a_object).GetTime(), a_bytes);
		}

		public override object Current1()
		{
			return new j4o.util.Date(i_compareTo);
		}

		internal static string Now()
		{
			return com.db4o.Platform4.Format(new j4o.util.Date(), true);
		}

		internal override long Val(object obj)
		{
			return ((j4o.util.Date)obj).GetTime();
		}

		internal override bool IsEqual1(object obj)
		{
			return obj is j4o.util.Date && Val(obj) == i_compareTo;
		}

		internal override bool IsGreater1(object obj)
		{
			return obj is j4o.util.Date && Val(obj) > i_compareTo;
		}

		internal override bool IsSmaller1(object obj)
		{
			return obj is j4o.util.Date && Val(obj) < i_compareTo;
		}
	}
}
