/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o
{
	internal class YapFieldVersion : com.db4o.YapFieldVirtual
	{
		internal YapFieldVersion(com.db4o.YapStream stream) : base()
		{
			i_name = com.db4o.ext.VirtualField.VERSION;
			i_handler = new com.db4o.YLong(stream);
		}

		public override void AddFieldIndex(com.db4o.inside.marshall.MarshallerFamily mf, 
			com.db4o.YapWriter writer, bool isnew)
		{
			com.db4o.YLong.WriteLong(writer.GetStream().BootRecord().NextVersion(), writer);
		}

		public override void Delete(com.db4o.inside.marshall.MarshallerFamily mf, com.db4o.YapWriter
			 a_bytes, bool isUpdate)
		{
			a_bytes.IncrementOffset(LinkLength());
		}

		internal override void Instantiate1(com.db4o.Transaction a_trans, com.db4o.YapObject
			 a_yapObject, com.db4o.YapReader a_bytes)
		{
			a_yapObject.i_virtualAttributes.i_version = com.db4o.YLong.ReadLong(a_bytes);
		}

		internal override void Marshall1(com.db4o.YapObject a_yapObject, com.db4o.YapWriter
			 a_bytes, bool a_migrating, bool a_new)
		{
			com.db4o.YapStream stream = a_bytes.GetStream().i_parent;
			com.db4o.PBootRecord br = stream.BootRecord();
			if (!a_migrating)
			{
				if (br != null)
				{
					a_yapObject.i_virtualAttributes.i_version = br.NextVersion();
				}
			}
			else
			{
				if (br != null)
				{
					br.SetDirty();
				}
			}
			if (a_yapObject.i_virtualAttributes == null)
			{
				com.db4o.YLong.WriteLong(0, a_bytes);
			}
			else
			{
				com.db4o.YLong.WriteLong(a_yapObject.i_virtualAttributes.i_version, a_bytes);
			}
		}

		public override int LinkLength()
		{
			return com.db4o.YapConst.YAPLONG_LENGTH;
		}

		internal override void MarshallIgnore(com.db4o.YapWriter writer)
		{
			com.db4o.YLong.WriteLong(0, writer);
		}
	}
}
