/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.foundation.network
{
	public class YapSocketReal : com.db4o.foundation.network.YapSocket
	{
		private j4o.net.Socket _socket;

		private j4o.io.OutputStream _out;

		private j4o.io.InputStream _in;

		private string _hostName;

		public YapSocketReal(string hostName, int port) : this(new j4o.net.Socket(hostName
			, port))
		{
			_hostName = hostName;
		}

		public YapSocketReal(j4o.net.Socket socket)
		{
			_socket = socket;
			_out = _socket.GetOutputStream();
			_in = _socket.GetInputStream();
		}

		public virtual void Close()
		{
			_socket.Close();
		}

		public virtual void Flush()
		{
			_out.Flush();
		}

		public virtual bool IsConnected()
		{
			return com.db4o.Platform4.IsConnected(_socket);
		}

		public virtual int Read()
		{
			return _in.Read();
		}

		public virtual int Read(byte[] a_bytes, int a_offset, int a_length)
		{
			return _in.Read(a_bytes, a_offset, a_length);
		}

		public virtual void SetSoTimeout(int timeout)
		{
			try
			{
				_socket.SetSoTimeout(timeout);
			}
			catch (System.Net.Sockets.SocketException e)
			{
				j4o.lang.JavaSystem.PrintStackTrace(e);
			}
		}

		public virtual void Write(byte[] bytes)
		{
			_out.Write(bytes);
		}

		public virtual void Write(byte[] bytes, int off, int len)
		{
			_out.Write(bytes, off, len);
		}

		public virtual void Write(int i)
		{
			_out.Write(i);
		}

		public virtual com.db4o.foundation.network.YapSocket OpenParalellSocket()
		{
			if (_hostName == null)
			{
				throw new System.IO.IOException("Cannot open parallel socket - invalid state.");
			}
			return new com.db4o.foundation.network.YapSocketReal(_hostName, _socket.GetPort()
				);
		}
	}
}
