/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.inside.convert
{
	/// <exclude></exclude>
	public class Converter
	{
		public const int VERSION = com.db4o.inside.marshall.MarshallerFamily.LEGACY ? 0 : 
			5;

		private com.db4o.foundation.Hashtable4 _conversions;

		public static bool Convert(com.db4o.YapFile file, com.db4o.YapConfigBlock config)
		{
			if (config.ConverterVersion() >= VERSION)
			{
				return false;
			}
			com.db4o.inside.convert.Converter converter = new com.db4o.inside.convert.Converter
				();
			converter.Run(file, config);
			return true;
		}

		private Converter()
		{
			_conversions = new com.db4o.foundation.Hashtable4(1);
			new com.db4o.inside.convert.conversions.CommonConversions(this);
		}

		public virtual void Register(int idx, com.db4o.inside.convert.Conversion conversion
			)
		{
			if (_conversions.Get(idx) != null)
			{
				com.db4o.inside.Exceptions4.ShouldNeverHappen();
			}
			_conversions.Put(idx, conversion);
		}

		private void Run(com.db4o.YapFile file, com.db4o.YapConfigBlock config)
		{
			int start = config.ConverterVersion();
			for (int i = start; i <= VERSION; i++)
			{
				com.db4o.inside.convert.Conversion conversion = (com.db4o.inside.convert.Conversion
					)_conversions.Get(i);
				if (conversion != null)
				{
					conversion.SetFile(file);
					conversion.Run();
				}
			}
			config.ConverterVersion(VERSION);
			config.Write();
		}
	}
}
