/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.inside.marshall
{
	/// <exclude></exclude>
	public class MarshallerFamily
	{
		public const bool LEGACY = false;

		public readonly com.db4o.inside.marshall.ArrayMarshaller _array;

		public readonly com.db4o.inside.marshall.ObjectMarshaller _object;

		public readonly com.db4o.inside.marshall.PrimitiveMarshaller _primitive;

		public readonly com.db4o.inside.marshall.StringMarshaller _string;

		public readonly com.db4o.inside.marshall.UntypedMarshaller _untyped;

		private static readonly com.db4o.inside.marshall.MarshallerFamily[] allVersions = 
			new com.db4o.inside.marshall.MarshallerFamily[] { new com.db4o.inside.marshall.MarshallerFamily
			(new com.db4o.inside.marshall.ArrayMarshaller0(), new com.db4o.inside.marshall.ObjectMarshaller0
			(), new com.db4o.inside.marshall.PrimitiveMarshaller0(), new com.db4o.inside.marshall.StringMarshaller0
			(), new com.db4o.inside.marshall.UntypedMarshaller0()), new com.db4o.inside.marshall.MarshallerFamily
			(new com.db4o.inside.marshall.ArrayMarshaller1(), new com.db4o.inside.marshall.ObjectMarshaller1
			(), new com.db4o.inside.marshall.PrimitiveMarshaller1(), new com.db4o.inside.marshall.StringMarshaller1
			(), new com.db4o.inside.marshall.UntypedMarshaller1()) };

		private static readonly int CURRENT_VERSION = LEGACY ? 0 : allVersions.Length - 1;

		private MarshallerFamily(com.db4o.inside.marshall.ArrayMarshaller arrayMarshaller
			, com.db4o.inside.marshall.ObjectMarshaller objectMarshaller, com.db4o.inside.marshall.PrimitiveMarshaller
			 primitiveMarshaller, com.db4o.inside.marshall.StringMarshaller stringMarshaller
			, com.db4o.inside.marshall.UntypedMarshaller untypedMarshaller)
		{
			_array = arrayMarshaller;
			_array._family = this;
			_object = objectMarshaller;
			_object._family = this;
			_primitive = primitiveMarshaller;
			_primitive._family = this;
			_string = stringMarshaller;
			_untyped = untypedMarshaller;
			_untyped._family = this;
		}

		public static com.db4o.inside.marshall.MarshallerFamily ForVersion(int n)
		{
			return allVersions[n];
		}

		public static com.db4o.inside.marshall.MarshallerFamily Current()
		{
			return ForVersion(CURRENT_VERSION);
		}
	}
}
