/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.inside.marshall
{
	public abstract class StringMarshaller
	{
		public abstract bool InlinedStrings();

		public abstract void CalculateLengths(com.db4o.Transaction trans, com.db4o.inside.marshall.ObjectHeaderAttributes
			 header, bool topLevel, object obj, bool withIndirection);

		protected int LinkLength()
		{
			return com.db4o.YapConst.YAPINT_LENGTH + com.db4o.YapConst.YAPID_LENGTH;
		}

		public abstract object WriteNew(object a_object, bool topLevel, com.db4o.YapWriter
			 a_bytes, bool redirect);

		public string Read(com.db4o.YapStream stream, com.db4o.YapReader reader)
		{
			if (reader == null)
			{
				return null;
			}
			string ret = ReadShort(stream, reader);
			return ret;
		}

		public virtual string ReadFromOwnSlot(com.db4o.YapStream stream, com.db4o.YapReader
			 reader)
		{
			try
			{
				return Read(stream, reader);
			}
			catch (System.Exception e)
			{
				if (com.db4o.Deploy.debug || com.db4o.Debug.atHome)
				{
					j4o.lang.JavaSystem.PrintStackTrace(e);
				}
			}
			return "";
		}

		public virtual string ReadFromParentSlot(com.db4o.YapStream stream, com.db4o.YapReader
			 reader, bool redirect)
		{
			if (!redirect)
			{
				return Read(stream, reader);
			}
			return Read(stream, ReadSlotFromParentSlot(stream, reader));
		}

		public abstract com.db4o.YapWriter ReadIndexEntry(com.db4o.YapWriter parentSlot);

		public static string ReadShort(com.db4o.YapStream stream, com.db4o.YapReader a_bytes
			)
		{
			int length = a_bytes.ReadInt();
			if (length > com.db4o.YapConst.MAXIMUM_BLOCK_SIZE)
			{
				throw new com.db4o.CorruptionException();
			}
			if (length > 0)
			{
				string str = stream.StringIO().Read(a_bytes, length);
				return str;
			}
			return "";
		}

		public abstract com.db4o.YapReader ReadSlotFromParentSlot(com.db4o.YapStream stream
			, com.db4o.YapReader reader);

		public static com.db4o.YapReader WriteShort(com.db4o.YapStream stream, string str
			)
		{
			com.db4o.YapReader reader = new com.db4o.YapReader(stream.StringIO().Length(str));
			WriteShort(stream, str, reader);
			return reader;
		}

		public static void WriteShort(com.db4o.YapStream stream, string str, com.db4o.YapReader
			 reader)
		{
			int length = str.Length;
			reader.WriteInt(length);
			stream.StringIO().Write(reader, str);
		}
	}
}
