/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.inside.marshall
{
	public class StringMarshaller0 : com.db4o.inside.marshall.StringMarshaller
	{
		public override bool InlinedStrings()
		{
			return false;
		}

		public override void CalculateLengths(com.db4o.Transaction trans, com.db4o.inside.marshall.ObjectHeaderAttributes
			 header, bool topLevel, object obj, bool withIndirection)
		{
		}

		public override object WriteNew(object a_object, bool topLevel, com.db4o.YapWriter
			 a_bytes, bool redirect)
		{
			if (a_object == null)
			{
				a_bytes.WriteEmbeddedNull();
				return null;
			}
			com.db4o.YapStream stream = a_bytes.GetStream();
			string str = (string)a_object;
			int length = stream.StringIO().Length(str);
			com.db4o.YapWriter bytes = new com.db4o.YapWriter(a_bytes.GetTransaction(), length
				);
			WriteShort(stream, str, bytes);
			bytes.SetID(a_bytes._offset);
			a_bytes.GetStream().WriteEmbedded(a_bytes, bytes);
			a_bytes.IncrementOffset(com.db4o.YapConst.YAPID_LENGTH);
			a_bytes.WriteInt(length);
			return bytes;
		}

		public override com.db4o.YapWriter ReadIndexEntry(com.db4o.YapWriter parentSlot)
		{
			return parentSlot.GetStream().ReadObjectWriterByAddress(parentSlot.GetTransaction
				(), parentSlot.ReadInt(), parentSlot.ReadInt());
		}

		public override com.db4o.YapReader ReadSlotFromParentSlot(com.db4o.YapStream stream
			, com.db4o.YapReader reader)
		{
			return reader.ReadEmbeddedObject(stream.GetTransaction());
		}
	}
}
