/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using j4o.lang;
using com.db4o.ext;
namespace com.db4o.test {

   public class ExtMethods {
      
      public ExtMethods() : base() {
      }
      
      public void Test() {
         ExtMethods em1 = new ExtMethods();
         Tester.Store(em1);
         ExtObjectContainer eoc1 = Tester.ObjectContainer();
         Tester.Ensure(!eoc1.IsClosed());
         Tester.Ensure(eoc1.IsActive(em1));
         Tester.Ensure(eoc1.IsStored(em1));
         eoc1.Deactivate(em1, 1);
         Tester.Ensure(!eoc1.IsActive(em1));
         eoc1.Activate(em1, 1);
         Tester.Ensure(eoc1.IsActive(em1));
         long id1 = eoc1.GetID(em1);
         Tester.Ensure(eoc1.IsCached(id1));
         eoc1.Purge(em1);
         Tester.Ensure(!eoc1.IsCached(id1));
         Tester.Ensure(!eoc1.IsStored(em1));
         Tester.Ensure(!eoc1.IsActive(em1));
         eoc1.Bind(em1, id1);
         Tester.Ensure(eoc1.IsCached(id1));
         Tester.Ensure(eoc1.IsStored(em1));
         Tester.Ensure(eoc1.IsActive(em1));
         ExtMethods em21 = (ExtMethods)eoc1.GetByID(id1);
         Tester.Ensure(em1 == em21);
         eoc1.Purge();
         Tester.Ensure(eoc1.IsCached(id1));
         Tester.Ensure(eoc1.IsStored(em1));
         Tester.Ensure(eoc1.IsActive(em1));
         em21 = (ExtMethods)eoc1.GetByID(id1);
         Tester.Ensure(em1 == em21);
         Tester.Delete(em21);
         Tester.Commit();
         Tester.Ensure(!eoc1.IsCached(id1));
         Tester.Ensure(!eoc1.IsStored(em21));
         Tester.Ensure(!eoc1.IsActive(em21));
         Tester.Ensure(!eoc1.IsStored(null));
         Tester.Ensure(!eoc1.IsActive(null));
         Tester.Ensure(!eoc1.IsCached(0));
      }
   }
}