/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using System.Collections;

using com.db4o.query;

namespace com.db4o.test {

    public class HoldsAnArrayList {

        public ArrayList something = new ArrayList();

        public HoldsAnArrayList (){
            something.AddRange(new char[] {'1', '2'});
        }

        public void Configure(){

            // Both of the following configuration settings work.
            // They can be used alternatively.

            Db4o.Configure().UpdateDepth(3);

            // Db4o.Configure().ObjectClass(typeof(HoldsAnArrayList)).CascadeOnUpdate(true);
        }

        public void Store(){
            Tester.Store(new HoldsAnArrayList());
        }

        public void Test(){
            Query q = Tester.Query();
            q.Constrain(typeof(HoldsAnArrayList));
            ObjectSet objectSet = q.Execute();
            while(objectSet.HasNext()){
                HoldsAnArrayList obj = (HoldsAnArrayList)objectSet.Next();
                obj.something.Add('3');
                Tester.Store(obj);

                Tester.ReOpen();
                q = Tester.Query();
                q.Constrain(typeof(HoldsAnArrayList));
                objectSet = q.Execute();
                while(objectSet.HasNext()){
                    HoldsAnArrayList haal = (HoldsAnArrayList)objectSet.Next();
                    Tester.Ensure(haal.something.Count > 2);
                }

            }
        }
    }
}