/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using j4o.lang;
using com.db4o;
namespace com.db4o.test {

   public class IsStored {
      
      public IsStored() : base() {
      }
      internal String myString;
      
      public void Test() {
         ObjectContainer con = Tester.ObjectContainer();
         Tester.DeleteAllInstances(this);
         IsStored isStored1 = new IsStored();
         isStored1.myString = "isStored";
         con.Set(isStored1);
         Tester.Ensure(con.Ext().IsStored(isStored1));
         Tester.Ensure(Tester.Occurrences(this) == 1);
         con.Delete(isStored1);
         Tester.Ensure(!con.Ext().IsStored(isStored1));
         Tester.Ensure(Tester.Occurrences(this) == 0);
         con.Commit();
         if (con.Ext().IsStored(isStored1)) {
            if (!Tester.clientServer) {
               Tester.Error();
            }
         }
         Tester.Ensure(Tester.Occurrences(this) == 0);
         con.Set(isStored1);
         Tester.Ensure(con.Ext().IsStored(isStored1));
         Tester.Ensure(Tester.Occurrences(this) == 1);
         con.Commit();
         Tester.Ensure(con.Ext().IsStored(isStored1));
         Tester.Ensure(Tester.Occurrences(this) == 1);
         con.Delete(isStored1);
         Tester.Ensure(!con.Ext().IsStored(isStored1));
         Tester.Ensure(Tester.Occurrences(this) == 0);
         con.Commit();
         if (con.Ext().IsStored(isStored1)) {
            if (!Tester.clientServer) {
               Tester.Error();
            }
         }
         Tester.Ensure(Tester.Occurrences(this) == 0);
      }
   }
}