/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using System.Collections;
using com.db4o;
using com.db4o.query;
using com.db4o.test;

namespace com.db4o.test
{
	internal class Sortable
	{
		public String a;
		
		public Sortable(String a)
		{
			this.a=a;
		}
	}
	
	internal class SortableComparator : QueryComparator
	{
		public int Compare(Object first, Object second) {
			return ((Sortable)first).a.CompareTo(((Sortable)second).a);
		}
	}

	public class SortedSameOrder
	{
		public void Store()
		{
			Tester.Store(new Sortable("a"));
			Tester.Store(new Sortable("c"));
			Tester.Store(new Sortable("b"));
		}
		
		public void Test()
		{
			Query query=Tester.Query();
			query.Constrain(typeof(Sortable));
			SortableComparator cmp = new SortableComparator();
			query.SortBy(cmp);
			ObjectSet result=query.Execute();
			
			Object last=null;
			while(result.HasNext()) {
				Object cur=result.Next();
				assertAscending(last,cur,cmp);
				last=cur;
			}
			last=null;
			result.Reset();

			for(int idx=0;idx<result.Count;idx++) {
				Object cur=result[idx];
				assertAscending(last,cur,cmp);
				last=cur;
			}
			last=null;
			result.Reset();

			foreach(Object cur in result) {
				assertAscending(last,cur,cmp);
				last=cur;
			}
		}
		
		private void assertAscending(Object a,Object b,QueryComparator cmp)
		{
			Tester.Ensure(a==null||cmp.Compare(a,b)<=0);
		}
	}
}