/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;

using com.db4o.query;
using com.db4o.config.attributes;

namespace com.db4o.test.config.attributes {
	
	public class IndexedWithAttributeByIdentity {
		
		[Indexed]
		Atom atom;

		const int COUNT = 10;
		const string NAME_PREFIX = "iwabi_";

		public void Configure ()
		{
		}

		public void Store ()
		{
			for (int i = 0; i < COUNT; i++) {
				IndexedWithAttributeByIdentity iwabi = new IndexedWithAttributeByIdentity ();
				iwabi.atom = new Atom (NAME_PREFIX + i);
				Tester.Store (iwabi);
			}
		}

		public void Test ()
		{
			for (int i = 0; i < COUNT; i++) {
				Query q = Tester.Query ();
				q.Constrain (typeof (Atom));
				q.Descend ("name").Constrain (NAME_PREFIX + i);
				ObjectSet objectSet = q.Execute ();
				Atom child = (Atom) objectSet.Next ();

				q = Tester.Query ();
				q.Constrain (typeof (IndexedWithAttributeByIdentity));
				q.Descend ("atom").Constrain (child).Identity ();
				objectSet = q.Execute ();
				Tester.Ensure (objectSet.Size () == 1);

				IndexedWithAttributeByIdentity iwabi = (IndexedWithAttributeByIdentity) objectSet.Next ();
				Tester.Ensure (iwabi.atom == child);
			}
		}
	}
}
