/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.test.nativequeries
{
#if NET_2_0
	using System;
	using System.Collections.Generic;
	using com.db4o;
	using com.db4o.ext;
    public class ListElementByIdentity
    {

        IList<LebiElement> _list;
        
        public void Store()
        {
            Store("1");
            Store("2");
            Store("3");
            Store("4");
        }

        public void Test()
        {
            ExtObjectContainer oc = Tester.ObjectContainer();

            LebiElement elem = (LebiElement)oc.Get(new LebiElement("23"))[0];

            IList <ListElementByIdentity> res = oc.Query<ListElementByIdentity>(delegate(ListElementByIdentity lebi)
            {
                return lebi._list.Contains(elem);
            });

            Tester.Ensure(res.Count == 1);
            Tester.Ensure(res[0]._list[3]._name.Equals("23"));

        }

        private void Store(string prefix)
        {
            ListElementByIdentity lebi = new ListElementByIdentity();
            lebi.CreateListElements(prefix);
            Tester.Store(lebi);
        }

        private void CreateListElements(string prefix)
        {
            _list = new List<LebiElement>();
            _list.Add(new LebiElement(prefix + "0"));
            _list.Add(new LebiElement(prefix + "1"));
            _list.Add(new LebiElement(prefix + "2"));
            _list.Add(new LebiElement(prefix + "3"));
        }


    }

    public class LebiElement {

        public string _name;

        public LebiElement (string name){
            _name = name;
        }
    }
#endif

}
