/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace com.db4o.test.net2
{
#if NET_2_0 || CF_2_0
    using System;
	using System.Text;
	using com.db4o;
	using com.db4o.test;
	using com.db4o.query;

	class SimpleGenericType<T>
	{
		public T value;

		public SimpleGenericType(T value)
		{
			this.value = value;
		}
	}

	class Net2SimpleGenericType
	{
		public void StoreOne()
		{
			Tester.Store(new SimpleGenericType<string>("Will it work?"));
			Tester.Store(new SimpleGenericType<int>(42));
		}

		public void Test()
		{
			TstGenericType("Will it work?");
			TstGenericType(42);
		}

		private void TstGenericType<T>(T expectedValue)
		{
			Query query = Tester.Query();
			query.Constrain(typeof(SimpleGenericType<T>));

			EnsureGenericItem<T>(expectedValue, query.Execute());

			query = Tester.Query();
			query.Constrain(typeof(SimpleGenericType<T>));
			query.Descend("value").Constrain(expectedValue);
			EnsureGenericItem<T>(expectedValue, query.Execute());
		}

		private static void EnsureGenericItem<T>(T expectedValue, ObjectSet os)
		{
			Tester.EnsureEquals(1, os.Size());

			SimpleGenericType<T> item = (SimpleGenericType<T>)os.Next();
			Tester.EnsureEquals(expectedValue, item.value);
		}
	}
#endif
}
