/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using j4o.lang;
using com.db4o;
using com.db4o.query;
using com.db4o.test.soda;
namespace com.db4o.test.soda.classes.wrapper.typed {

    public class STBooleanWT : STClass {
        static internal String DESCENDANT = "i_boolean";
        [Transient] public static SodaTest st;
        internal Boolean i_boolean;
      
        public STBooleanWT() : base() {
        }
      
        internal STBooleanWT(bool a_boolean) : base() {
            i_boolean = System.Convert.ToBoolean(a_boolean);
        }
      
        public Object[] Store() {
            return new Object[]{
                                   new STBooleanWT(false),
                                   new STBooleanWT(true),
                                   new STBooleanWT(false),
                                   new STBooleanWT(false),
                                   new STBooleanWT()         };
        }
      
        public void TestEqualsTrue() {
            Query q1 = st.Query();
            q1.Constrain(new STBooleanWT(true));
            Object[] r1 = Store();
            st.ExpectOne(q1, new STBooleanWT(true));
        }
      
        public void TestEqualsFalse() {
            Query q1 = st.Query();
            q1.Constrain(new STBooleanWT(false));
            q1.Descend(DESCENDANT).Constrain(System.Convert.ToBoolean(false));
            Object[] r1 = Store();
            st.Expect(q1, new Object[]{
                                          r1[0],
                                          r1[2],
                                          r1[3],
                                          r1[4]         });
        }
      
        public void TestNull() {
            Query q1 = st.Query();
            q1.Constrain(new STBooleanWT());
            q1.Descend(DESCENDANT).Constrain(null);
            Object[] r1 = Store();
            st.ExpectNone(q1);
        }
      
        public void TestNullOrTrue() {
            Query q1 = st.Query();
            q1.Constrain(new STBooleanWT());
            Query qd1 = q1.Descend(DESCENDANT);
            qd1.Constrain(null).Or(qd1.Constrain(System.Convert.ToBoolean(true)));
            Object[] r1 = Store();
            st.Expect(q1, new Object[]{
                                          r1[1]
                                      });
        }
      
        public void TestNotNullAndFalse() {
            Query q1 = st.Query();
            q1.Constrain(new STBooleanWT());
            Query qd1 = q1.Descend(DESCENDANT);
            qd1.Constrain(null).Not().And(qd1.Constrain(System.Convert.ToBoolean(false)));
            Object[] r1 = Store();
            st.Expect(q1, new Object[]{
                                          r1[0],
                                          r1[2],
                                          r1[3],
                                          r1[4]
            });
        }
    }
}