/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Cil {

	using System.Collections;

	public sealed class OpCodes {

		OpCodes()
		{
		}

<% $ops.each { |op| %>		public static readonly OpCode <%=op.field_name%> = new OpCode (
			"<%=op.name%>", <%=op.op1%>, <%=op.op2%>, <%=op.size%>, <%=op.flowcontrol%>,
			<%=op.opcodetype%>, <%=op.operandtype%>,
			<%=op.stackbehaviourpop%>, <%=op.stackbehaviourpush%>);
<% } %>		public sealed class Cache {

			public static readonly Cache Instance = new Cache ();

			IDictionary m_cache;
			OpCode [] m_oneByteOpCode;
			OpCode [] m_twoBytesOpCodes;

			public OpCode this [string name] {
				get { return (OpCode) m_cache [name]; }
			}

			internal IDictionary Dictionary {
				get { return m_cache; }
			}

			internal OpCode [] OneByteOpCode {
				get { return m_oneByteOpCode; }
			}

			internal OpCode [] TwoBytesOpCode {
				get { return m_twoBytesOpCodes; }
			}

			Cache ()
			{
				m_cache = new Hashtable ();
<%
	oboc = Array.new
	tboc = Array.new
	$ops.each { |op|
		if op.op1 == "0xff"
			oboc.push(op)
		else
			tboc.push(op)
		end
	}
%>				m_oneByteOpCode = new OpCode [<%=oboc[oboc.length - 1].op2%> + 1];
				m_twoBytesOpCodes = new OpCode [<%=tboc[tboc.length - 1].op2%> + 1];
<% oboc.each { |op| %>				m_oneByteOpCode [<%=op.op2%>] = OpCodes.<%=op.field_name%>;
<% }
   tboc.each { |op| %>				m_twoBytesOpCodes [<%=op.op2%>] = OpCodes.<%=op.field_name%>;
<% } %>
<% $ops.each { |op| %>				m_cache ["<%=op.name%>"] = OpCodes.<%=op.field_name%>;
<% } %>			}
		}
	}
}
