/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Binary {

	public sealed class PEOptionalHeader : IHeader, IBinaryVisitable {

		public StandardFieldsHeader StandardFields;
		public NTSpecificFieldsHeader NTSpecificFields;
		public DataDirectoriesHeader DataDirectories;

		internal PEOptionalHeader ()
		{
			StandardFields = new StandardFieldsHeader ();
			NTSpecificFields = new NTSpecificFieldsHeader ();
			DataDirectories = new DataDirectoriesHeader ();
		}

		public void SetDefaultValues ()
		{
		}

		public void Accept (IBinaryVisitor visitor)
		{
			visitor.VisitPEOptionalHeader (this);

			StandardFields.Accept (visitor);
			NTSpecificFields.Accept (visitor);
			DataDirectories.Accept (visitor);
		}
<% header = $headers["PEOptionalHeader.StandardFieldsHeader"] %>
		public sealed class StandardFieldsHeader : IHeader, IBinaryVisitable {

<% header.fields.each { |f| %>			public <%=f.type%> <%=f.property_name%>;
<% } %>
			internal StandardFieldsHeader ()
			{
			}

			public void SetDefaultValues ()
			{
<% header.fields.each { |f| unless f.default.nil? %>				<%=f.property_name%> = <%=f.default%>;
<% end } %>			}

			public void Accept (IBinaryVisitor visitor)
			{
				visitor.VisitStandardFieldsHeader (this);
			}
		}
<% header = $headers["PEOptionalHeader.NTSpecificFieldsHeader"] %>
		public sealed class NTSpecificFieldsHeader : IHeader, IBinaryVisitable {

<% header.fields.each { |f| %>			public <%=f.type%> <%=f.property_name%>;
<% } %>
			internal NTSpecificFieldsHeader ()
			{
			}

			public void SetDefaultValues ()
			{
<% header.fields.each { |f| unless f.default.nil? %>				<%=f.property_name%> = <%=f.default%>;
<% end } %>			}

			public void Accept (IBinaryVisitor visitor)
			{
				visitor.VisitNTSpecificFieldsHeader (this);
			}
		}
<% header = $headers["PEOptionalHeader.DataDirectoriesHeader"] %>
		public sealed class DataDirectoriesHeader : IHeader, IBinaryVisitable {

<% header.fields.each { |f| %>			public <%=f.type%> <%=f.property_name%>;
<% } %>
			internal DataDirectoriesHeader ()
			{
			}

			public void SetDefaultValues ()
			{
<% header.fields.each { |f| unless f.default.nil? %>				<%=f.property_name%> = <%=f.default%>;
<% end } %>			}

			public void Accept (IBinaryVisitor visitor)
			{
				visitor.VisitDataDirectoriesHeader (this);
			}
		}
	}
}
