/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Tests {

	using System;
	using System.IO;
	using System.Collections;

	using NUnit.Framework;

	using Mono.Cecil;

	class Language {

		string m_compiler;
		string m_command;

		public string Compiler {
			get { return m_compiler; }
		}

		public string Command {
			get { return m_command; }
		}

		public Language (string compiler, string command)
		{
			m_compiler = compiler;
			m_command = command;
		}

		static IDictionary m_languages = new Hashtable ();

		static Language ()
		{
<%
	$languages.each { |l|
%>
			m_languages.Add ("<%= l.name %>", new Language (
				"<%= l.compiler %>",
				"<%= l.command %>"
			));
<%
	}
%>
		}

		public static Language GetLanguage (string name)
		{
			return (Language) m_languages [name];
		}
	}

	class TestCase {

		Language m_lang;
		FileInfo m_file;

		public TestCase (Language lang, string file)
		{
			m_lang = lang;
			m_file = new FileInfo (file);
		}
	}

	[TestFixture]
	class GeneratedTests {

		void Test (TestCase test)
		{
		}

<%
	$tests.each { |test|
%>
		[Test]
		public void <%= test.method %> ()
		{
			Test (new TestCase (
				Language.GetLanguage ("<%= test.lang.name %>"),
				@"<%= test.file %>"));
		}
<%
	}
%>
	}
}
