/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Binary {

	public sealed class ImportAddressTable : IBinaryVisitable {

		public RVA HintNameTableRVA;

		internal ImportAddressTable ()
		{
		}

		public void Accept (IBinaryVisitor visitor)
		{
			visitor.VisitImportAddressTable (this);
		}
	}

	public sealed class ImportTable : IBinaryVisitable {

		public RVA ImportLookupTable;
		public uint DateTimeStamp;
		public uint ForwardChain;
		public RVA Name;
		public RVA ImportAddressTable;

		internal ImportTable ()
		{
		}

		public void Accept (IBinaryVisitor visitor)
		{
			visitor.VisitImportTable (this);
		}
	}

	public sealed class ImportLookupTable : IBinaryVisitable {

		public RVA HintNameRVA;

		internal ImportLookupTable ()
		{
		}

		public void Accept (IBinaryVisitor visitor)
		{
			visitor.VisitImportLookupTable (this);
		}
	}

	public sealed class HintNameTable : IBinaryVisitable {

		public const string RuntimeMainExe = "_CorExeMain";
		public const string RuntimeMainDll = "_CorDllMain";
		public const string RuntimeCorEE = "mscoree.dll";

		public ushort Hint;
		public string RuntimeMain;
		public string RuntimeLibrary;
		public ushort EntryPoint;
		public RVA RVA;

		internal HintNameTable ()
		{
		}

		public void Accept (IBinaryVisitor visitor)
		{
			visitor.VisitHintNameTable (this);
		}
	}
}
