/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Cil {

	using Mono.Cecil;

	public sealed class ExceptionHandler : IExceptionHandler {

		Instruction m_tryStart;
		Instruction m_tryEnd;
		Instruction m_filterStart;
		Instruction m_filterEnd;
		Instruction m_handlerStart;
		Instruction m_handlerEnd;

		TypeReference m_catchType;
		ExceptionHandlerType m_type;

		public Instruction TryStart {
			get { return m_tryStart; }
			set { m_tryStart = value as Instruction; }
		}

		public Instruction TryEnd {
			get { return m_tryEnd; }
			set { m_tryEnd = value as Instruction; }
		}

		public Instruction FilterStart {
			get { return m_filterStart; }
			set { m_filterStart = value as Instruction; }
		}

		public Instruction FilterEnd {
			get { return m_filterEnd; }
			set { m_filterEnd = value as Instruction; }
		}

		public Instruction HandlerStart {
			get { return m_handlerStart; }
			set { m_handlerStart = value as Instruction; }
		}

		public Instruction HandlerEnd {
			get { return m_handlerEnd; }
			set { m_handlerEnd = value as Instruction; }
		}

		public TypeReference CatchType {
			get { return m_catchType; }
			set { m_catchType = value; }
		}

		public ExceptionHandlerType Type {
			get { return m_type; }
			set { m_type = value; }
		}

		public ExceptionHandler (ExceptionHandlerType type)
		{
			m_type = type;
		}

		public void Accept (ICodeVisitor visitor)
		{
			visitor.VisitExceptionHandler (this);
		}
	}
}
