/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Cil {

	public interface ICilWorker {

		MethodBody GetBody ();

		Instruction Emit (OpCode opcode);

		Instruction Emit (OpCode opcode, TypeReference type);
		Instruction Emit (OpCode opcode, MethodReference meth);
		Instruction Emit (OpCode opcode, FieldReference field);

		Instruction Emit (OpCode opcode, string str);
		Instruction Emit (OpCode opcode, byte b);
		Instruction Emit (OpCode opcode, sbyte b);
		Instruction Emit (OpCode opcode, int i);
		Instruction Emit (OpCode opcode, long l);
		Instruction Emit (OpCode opcode, float f);
		Instruction Emit (OpCode opcode, double d);

		Instruction Emit (OpCode opcode, Instruction target);
		Instruction Emit (OpCode opcode, Instruction [] targets);

		Instruction Emit (OpCode opcode, VariableDefinition var);
		Instruction Emit (OpCode opcode, ParameterDefinition param);

		Instruction Create (OpCode opcode);

		Instruction Create (OpCode opcode, TypeReference type);

		Instruction Create (OpCode opcode, MethodReference meth);
		Instruction Create (OpCode opcode, FieldReference field);

		Instruction Create (OpCode opcode, string str);
		Instruction Create (OpCode opcode, byte b);
		Instruction Create (OpCode opcode, sbyte b);
		Instruction Create (OpCode opcode, int i);
		Instruction Create (OpCode opcode, long l);
		Instruction Create (OpCode opcode, float f);
		Instruction Create (OpCode opcode, double d);

		Instruction Create (OpCode opcode, Instruction target);
		Instruction Create (OpCode opcode, Instruction [] targets);

		Instruction Create (OpCode opcode, VariableDefinition var);

		Instruction Create (OpCode opcode, ParameterDefinition param);

		void InsertBefore (Instruction target, Instruction instr);
		void InsertAfter (Instruction target, Instruction instr);
		void Append (Instruction instr);
		void Replace (Instruction old, Instruction instr);
		void Remove (Instruction instr);
	}
}
