/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Cil {

	public sealed class VariableDefinition : IVariableDefinition {

		string m_name;
		int m_index;
		MethodDefinition m_method;
		TypeReference m_variableType;

		public string Name {
			get { return m_name; }
			set { m_name = value; }
		}

		public int Index {
			get { return m_index; }
			set { m_index = value; }
		}

		public MethodDefinition Method {
			get { return m_method; }
			set { m_method = value; }
		}

		public TypeReference VariableType {
			get { return m_variableType; }
			set { m_variableType = value; }
		}

		public VariableDefinition (TypeReference variableType)
		{
			m_variableType = variableType;
		}

		public VariableDefinition (string name, int index, MethodDefinition method, TypeReference variable) :
			this (variable)
		{
			m_name = name;
			m_index = index;
			m_method = method;
		}

		public override string ToString ()
		{
			if (m_name != null && m_name.Length > 0)
				return m_name;

			return string.Concat ("V_", m_index);
		}

		public void Accept (ICodeVisitor visitor)
		{
			visitor.VisitVariableDefinition (this);
		}
	}
}
