/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Metadata {

	public enum ElementType {
		End		 = 0x00,   // Marks end of a list
		Void		= 0x01,
		Boolean	 = 0x02,
		Char		= 0x03,
		I1		  = 0x04,
		U1		  = 0x05,
		I2		  = 0x06,
		U2		  = 0x07,
		I4		  = 0x08,
		U4		  = 0x09,
		I8		  = 0x0a,
		U8		  = 0x0b,
		R4		  = 0x0c,
		R8		  = 0x0d,
		String	  = 0x0e,
		Ptr		 = 0x0f,   // Followed by <type> token
		ByRef	   = 0x10,   // Followed by <type> token
		ValueType   = 0x11,   // Followed by <type> token
		Class	   = 0x12,   // Followed by <type> token
		Var        = 0x13,   // Followed by generic parameter number
		Array	   = 0x14,   // <type> <rank> <boundsCount> <bound1>  <loCount> <lo1>
		GenericInst = 0x15,   // <type> <type-arg-count> <type-1> ... <type-n> */
		TypedByRef  = 0x16,
		I		   = 0x18,   // System.IntPtr
		U		   = 0x19,   // System.UIntPtr
		FnPtr	   = 0x1b,   // Followed by full method signature
		Object	  = 0x1c,   // System.Object
		SzArray	 = 0x1d,   // Single-dim array with 0 lower bound
		MVar       = 0x1e,   // Followed by generic parameter number
		CModReqD	= 0x1f,   // Required modifier : followed by a TypeDef or TypeRef token
		CModOpt	 = 0x20,   // Optional modifier : followed by a TypeDef or TypeRef token
		Internal	= 0x21,   // Implemented within the CLI
		Modifier	= 0x40,   // Or'd with following element types
		Sentinel	= 0x41,   // Sentinel for varargs method signature
		Pinned	  = 0x45,   // Denotes a local variable that points at a pinned object

		// special undocumented constants
		Type		= 0x50,
		Boxed	   = 0x51,
		Enum		= 0x55
	}
}
