/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Metadata {

	using System;
	using System.IO;
	using System.Text;

	using Mono.Cecil;
	using Mono.Cecil.Binary;

	class MetadataInitializer : BaseMetadataVisitor {

		MetadataRoot m_root;

		public MetadataInitializer (ImageInitializer init)
		{
			m_root = init.Image.MetadataRoot;
		}

		public override void VisitMetadataRoot (MetadataRoot root)
		{
			root.Header = new MetadataRoot.MetadataRootHeader ();
			root.Streams = new MetadataStreamCollection ();
		}

		public override void VisitMetadataRootHeader (MetadataRoot.MetadataRootHeader header)
		{
			header.SetDefaultValues ();
		}

		public override void VisitMetadataStreamCollection (MetadataStreamCollection coll)
		{
			MetadataStream tables = new MetadataStream ();
			tables.Header.Name = MetadataStream.Tables;
			tables.Heap = MetadataHeap.HeapFactory (tables);
			TablesHeap th = tables.Heap as TablesHeap;
			th.Tables = new TableCollection (th);
			m_root.Streams.Add (tables);
		}

		public override void VisitTablesHeap (TablesHeap th)
		{
			th.Reserved = 0;
			th.MajorVersion = 1;
			th.MinorVersion = 0;
			th.Reserved2 = 1;
			th.Sorted = 0x2003301fa00;
		}
	}
}
