/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Metadata {

	public class MetadataStream : IMetadataVisitable {

		public const string Strings = "#Strings";
		public const string Tables = "#~";
		public const string IncrementalTables = "#-";
		public const string Blob = "#Blob";
		public const string GUID = "#GUID";
		public const string UserStrings = "#US";

		MetadataStreamHeader m_header;
		MetadataHeap m_heap;

		public MetadataStreamHeader Header {
			get { return m_header; }
			set { m_header = value; }
		}

		public MetadataHeap Heap {
			get { return m_heap; }
			set { m_heap = value; }
		}

		internal MetadataStream ()
		{
			m_header = new MetadataStreamHeader (this);
		}

		public void Accept (IMetadataVisitor visitor)
		{
			visitor.VisitMetadataStream (this);

			m_header.Accept (visitor);
			if (m_heap != null)
				m_heap.Accept (visitor);
		}

		public class MetadataStreamHeader : IMetadataVisitable {

			public uint Offset;
			public uint Size;
			public string Name;

			private MetadataStream m_stream;

			public MetadataStream Stream {
				get { return m_stream; }
			}

			internal MetadataStreamHeader (MetadataStream stream)
			{
				m_stream = stream;
			}

			public void Accept (IMetadataVisitor visitor)
			{
				visitor.VisitMetadataStreamHeader (this);
			}
		}
	}
}
