/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil.Metadata {

	using Mono.Cecil;

	public sealed class TypeDefTable : IMetadataTable {

		public const int RId = 0x02;

		RowCollection m_rows;

		public TypeDefRow this [int index] {
			get { return m_rows [index] as TypeDefRow; }
			set { m_rows [index] = value; }
		}

		public RowCollection Rows {
			get { return m_rows; }
			set { m_rows = value; }
		}

		public int Id {
			get { return RId; }
		}

		internal TypeDefTable ()
		{
		}

		public void Accept (IMetadataTableVisitor visitor)
		{
			visitor.VisitTypeDefTable (this);
			this.Rows.Accept (visitor.GetRowVisitor ());
		}
	}

	public sealed class TypeDefRow : IMetadataRow {

		public static readonly int RowSize = 24;
		public static readonly int RowColumns = 6;

		public TypeAttributes Flags;
		public uint Name;
		public uint Namespace;
		public MetadataToken Extends;
		public uint FieldList;
		public uint MethodList;

		internal TypeDefRow ()
		{
		}

		public void Accept (IMetadataRowVisitor visitor)
		{
			visitor.VisitTypeDefRow (this);
		}
	}
}
