/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	public sealed class ArrayDimension : IArrayDimension {

		int m_lowerBound;
		int m_upperBound;

		public int LowerBound {
			get { return m_lowerBound; }
			set { m_lowerBound = value; }
		}

		public int UpperBound {
			get { return m_upperBound; }
			set { m_upperBound = value; }
		}

		public ArrayDimension (int lb, int ub)
		{
			m_lowerBound = lb;
			m_upperBound = ub;
		}

		public override string ToString ()
		{
			if (m_upperBound == 0)
				return string.Empty;
			return string.Concat (m_lowerBound, "...", m_upperBound);
		}
	}
}
