/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System.Collections;

	public abstract class BaseReflectionVisitor : IReflectionVisitor {

		public virtual void VisitModuleDefinition (ModuleDefinition module)
		{
		}

		public virtual void VisitTypeDefinitionCollection (TypeDefinitionCollection types)
		{
		}

		public virtual void VisitTypeDefinition (TypeDefinition type)
		{
		}

		public virtual void VisitTypeReferenceCollection (TypeReferenceCollection refs)
		{
		}

		public virtual void VisitTypeReference (TypeReference type)
		{
		}

		public virtual void VisitMemberReferenceCollection (MemberReferenceCollection members)
		{
		}

		public virtual void VisitMemberReference (MemberReference member)
		{
		}

		public virtual void VisitInterfaceCollection (InterfaceCollection interfaces)
		{
		}

		public virtual void VisitInterface (TypeReference interf)
		{
		}

		public virtual void VisitExternTypeCollection (ExternTypeCollection externs)
		{
		}

		public virtual void VisitExternType (TypeReference externType)
		{
		}

		public virtual void VisitOverrideCollection (OverrideCollection meth)
		{
		}

		public virtual void VisitOverride (MethodReference ov)
		{
		}

		public virtual void VisitNestedTypeCollection (NestedTypeCollection nestedTypes)
		{
		}

		public virtual void VisitNestedType (TypeDefinition nestedType)
		{
		}

		public virtual void VisitParameterDefinitionCollection (ParameterDefinitionCollection parameters)
		{
		}

		public virtual void VisitParameterDefinition (ParameterDefinition parameter)
		{
		}

		public virtual void VisitMethodDefinitionCollection (MethodDefinitionCollection methods)
		{
		}

		public virtual void VisitMethodDefinition (MethodDefinition method)
		{
		}

		public virtual void VisitConstructorCollection (ConstructorCollection ctors)
		{
		}

		public virtual void VisitConstructor (MethodDefinition ctor)
		{
		}

		public virtual void VisitPInvokeInfo (PInvokeInfo pinvk)
		{
		}

		public virtual void VisitEventDefinitionCollection (EventDefinitionCollection events)
		{
		}

		public virtual void VisitEventDefinition (EventDefinition evt)
		{
		}

		public virtual void VisitFieldDefinitionCollection (FieldDefinitionCollection fields)
		{
		}

		public virtual void VisitFieldDefinition (FieldDefinition field)
		{
		}

		public virtual void VisitPropertyDefinitionCollection (PropertyDefinitionCollection properties)
		{
		}

		public virtual void VisitPropertyDefinition (PropertyDefinition property)
		{
		}

		public virtual void VisitSecurityDeclarationCollection (SecurityDeclarationCollection secDecls)
		{
		}

		public virtual void VisitSecurityDeclaration (SecurityDeclaration secDecl)
		{
		}

		public virtual void VisitCustomAttributeCollection (CustomAttributeCollection customAttrs)
		{
		}

		public virtual void VisitCustomAttribute (CustomAttribute customAttr)
		{
		}

		public virtual void VisitGenericParameterCollection (GenericParameterCollection genparams)
		{
		}

		public virtual void VisitGenericParameter (GenericParameter genparam)
		{
		}

		public virtual void VisitMarshalSpec (MarshalDesc marshalSpec)
		{
		}

		public virtual void TerminateModuleDefinition (ModuleDefinition module)
		{
		}

		protected void VisitCollection (ICollection coll)
		{
			if (coll.Count == 0)
				return;

			foreach (IReflectionVisitable visitable in coll)
				visitable.Accept (this);
		}
	}
}
