/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System.Collections;

	public abstract class BaseStructureVisitor : IReflectionStructureVisitor {

		public virtual void VisitAssemblyDefinition (AssemblyDefinition asm)
		{
		}

		public virtual void VisitAssemblyNameDefinition (AssemblyNameDefinition name)
		{
		}

		public virtual void VisitAssemblyNameReferenceCollection (AssemblyNameReferenceCollection names)
		{
		}

		public virtual void VisitAssemblyNameReference (AssemblyNameReference name)
		{
		}

		public virtual void VisitResourceCollection (ResourceCollection resources)
		{
		}

		public virtual void VisitEmbeddedResource (EmbeddedResource res)
		{
		}

		public virtual void VisitLinkedResource (LinkedResource res)
		{
		}

		public virtual void VisitAssemblyLinkedResource (AssemblyLinkedResource res)
		{
		}

		public virtual void VisitModuleDefinition (ModuleDefinition module)
		{
		}

		public virtual void VisitModuleDefinitionCollection (ModuleDefinitionCollection modules)
		{
		}

		public virtual void VisitModuleReference (ModuleReference module)
		{
		}

		public virtual void VisitModuleReferenceCollection (ModuleReferenceCollection modules)
		{
		}

		public virtual void TerminateAssemblyDefinition (AssemblyDefinition asm)
		{
		}

		protected void VisitCollection (ICollection coll)
		{
			if (coll.Count == 0)
				return;

			foreach (IReflectionStructureVisitable visitable in coll)
				visitable.Accept (this);
		}
	}
}
