/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System.Text;

	public sealed class GenericInstanceMethod : MethodSpecification, IGenericInstanceMethod {

		private GenericArgumentCollection m_genArgs;

		public GenericArgumentCollection GenericArguments {
			get {
				if (m_genArgs == null)
					m_genArgs = new GenericArgumentCollection (this);
				return m_genArgs;
			}
		}

		public GenericInstanceMethod (MethodReference elemMethod) : base (elemMethod)
		{
		}

		public override string ToString ()
		{
			StringBuilder sb = new StringBuilder ();
			MethodReference meth = this.ElementMethod;
			sb.Append (meth.ReturnType.ReturnType.FullName);
			sb.Append (" ");
			sb.Append (meth.DeclaringType.FullName);
			sb.Append ("::");
			sb.Append (meth.Name);
			sb.Append ("<");
			for (int i = 0; i < this.GenericArguments.Count; i++) {
				if (i > 0)
					sb.Append (",");
				sb.Append (this.GenericArguments [i].FullName);
			}
			sb.Append (">");
			sb.Append ("(");
			for (int i = 0; i < meth.Parameters.Count; i++) {
				sb.Append (meth.Parameters [i].ParameterType.FullName);
				if (i < meth.Parameters.Count - 1)
					sb.Append (",");
			}
			sb.Append (")");
			return sb.ToString ();
		}
	}
}
