/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System;
	using System.Collections;

	public class FieldDefinitionEventArgs : EventArgs {

		private FieldDefinition m_item;

		public FieldDefinition FieldDefinition {
			get { return m_item; }
		}

		public FieldDefinitionEventArgs (FieldDefinition item)
		{
			m_item = item;
		}
	}

	public delegate void FieldDefinitionEventHandler (
		object sender, FieldDefinitionEventArgs ea);

	public interface IFieldDefinitionCollection : IIndexedCollection, IReflectionVisitable {

		new FieldDefinition this [int index] { get; }

		TypeDefinition Container { get; }

		event FieldDefinitionEventHandler OnFieldDefinitionAdded;
		event FieldDefinitionEventHandler OnFieldDefinitionRemoved;

		void Add (FieldDefinition value);
		void Clear ();
		bool Contains (FieldDefinition value);
		int IndexOf (FieldDefinition value);
		void Insert (int index, FieldDefinition value);
		void Remove (FieldDefinition value);
		void RemoveAt (int index);

		FieldDefinition GetField (string name);
	}
}
