/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System;
	using System.Collections;

	public class MemberReferenceEventArgs : EventArgs {

		private MemberReference m_item;

		public MemberReference MemberReference {
			get { return m_item; }
		}

		public MemberReferenceEventArgs (MemberReference item)
		{
			m_item = item;
		}
	}

	public delegate void MemberReferenceEventHandler (
		object sender, MemberReferenceEventArgs ea);

	public interface IMemberReferenceCollection : IIndexedCollection, IReflectionVisitable {

		new MemberReference this [int index] { get; }

		ModuleDefinition Container { get; }

		event MemberReferenceEventHandler OnMemberReferenceAdded;
		event MemberReferenceEventHandler OnMemberReferenceRemoved;

		void Add (MemberReference value);
		void Clear ();
		bool Contains (MemberReference value);
		int IndexOf (MemberReference value);
		void Insert (int index, MemberReference value);
		void Remove (MemberReference value);
		void RemoveAt (int index);
	}
}
