/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System;

	using Mono.Cecil.Cil;

	public interface IMethodReference : IMethodSignature, IMemberReference,
		IGenericParameterProvider, IReflectionVisitable {
	}

	public interface IMethodDefinition : IMemberDefinition, IMethodReference,
		IHasSecurity, ICustomAttributeProvider {

		MethodAttributes Attributes { get; set; }
		MethodImplAttributes ImplAttributes { get; set; }
		MethodSemanticsAttributes SemanticsAttributes { get; set; }

		bool IsAbstract { get; set; }
		bool IsFinal { get; set; }
		bool IsHideBySignature { get; set; }
		bool IsNewSlot { get; set; }
		bool IsRuntimeSpecialName { get; set; }
		bool IsSpecialName { get; set; }
		bool IsStatic { get; set; }
		bool IsVirtual { get; set; }
		bool IsConstructor { get; }
		bool HasBody { get; }
		bool IsRuntime { get; set; }
		bool IsInternalCall { get; set; }

		OverrideCollection Overrides { get; }
		MethodBody Body { get; }
		PInvokeInfo PInvokeInfo { get; }

		ParameterDefinition This { get; }

		MethodDefinition Clone ();
	}
}
