/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	using System;
	using SR = System.Reflection;

	using Mono.Cecil.Metadata;

	public interface IModuleDefinition : ICustomAttributeProvider, IMetadataScope,
		IReflectionStructureVisitable, IReflectionVisitable {

		AssemblyDefinition Assembly { get; }

		Guid Mvid { get; set; }
		bool Main { get; }

		AssemblyNameReferenceCollection AssemblyReferences { get; }
		ModuleReferenceCollection ModuleReferences { get; }
		ResourceCollection Resources { get; }
		TypeDefinitionCollection Types { get; }
		ExternTypeCollection ExternTypes { get; }
		TypeReferenceCollection TypeReferences { get; }
		MemberReferenceCollection MemberReferences { get; }

		IMetadataTokenProvider LookupByToken (MetadataToken token);
		IMetadataTokenProvider LookupByToken (TokenType table, int rid);

		TypeReference Import (Type type);
		TypeReference Import (Type type, TypeDefinition context);
		MethodReference Import (SR.MethodBase meth);
		MethodReference Import (SR.MethodBase meth, TypeDefinition context);
		FieldReference Import (SR.FieldInfo field);
		FieldReference Import (SR.FieldInfo field, TypeDefinition context);

		TypeReference Import (TypeReference type);
		TypeReference Import (TypeReference type, TypeDefinition context);
		MethodReference Import (MethodReference meth);
		MethodReference Import (MethodReference meth, TypeDefinition context);
		FieldReference Import (FieldReference field);
		FieldReference Import (FieldReference field, TypeDefinition context);

		TypeDefinition Inject (TypeDefinition type);
		TypeDefinition Inject (TypeDefinition type, TypeDefinition context);
		MethodDefinition Inject (MethodDefinition meth);
		MethodDefinition Inject (MethodDefinition meth, TypeDefinition context);
		FieldDefinition Inject (FieldDefinition field);
		FieldDefinition Inject (FieldDefinition field, TypeDefinition context);

		void FullLoad ();

		byte [] GetAsByteArray (CustomAttribute ca);
		byte [] GetAsByteArray (SecurityDeclaration dec);

		CustomAttribute FromByteArray (MethodReference ctor, byte [] data);
		SecurityDeclaration FromByteArray (SecurityAction action, byte [] data);
	}
}
