/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Mono.Cecil {

	public interface IReflectionVisitor {

		void VisitModuleDefinition (ModuleDefinition module);
		void VisitTypeDefinitionCollection (TypeDefinitionCollection types);
		void VisitTypeDefinition (TypeDefinition type);
		void VisitTypeReferenceCollection (TypeReferenceCollection refs);
		void VisitTypeReference (TypeReference type);
		void VisitMemberReferenceCollection (MemberReferenceCollection members);
		void VisitMemberReference (MemberReference member);
		void VisitInterfaceCollection (InterfaceCollection interfaces);
		void VisitInterface (TypeReference interf);
		void VisitExternTypeCollection (ExternTypeCollection externs);
		void VisitExternType (TypeReference externType);
		void VisitOverrideCollection (OverrideCollection meth);
		void VisitOverride (MethodReference ov);
		void VisitNestedTypeCollection (NestedTypeCollection nestedTypes);
		void VisitNestedType (TypeDefinition nestedType);
		void VisitParameterDefinitionCollection (ParameterDefinitionCollection parameters);
		void VisitParameterDefinition (ParameterDefinition parameter);
		void VisitMethodDefinitionCollection (MethodDefinitionCollection methods);
		void VisitMethodDefinition (MethodDefinition method);
		void VisitConstructorCollection (ConstructorCollection ctors);
		void VisitConstructor (MethodDefinition ctor);
		void VisitPInvokeInfo (PInvokeInfo pinvk);
		void VisitEventDefinitionCollection (EventDefinitionCollection events);
		void VisitEventDefinition (EventDefinition evt);
		void VisitFieldDefinitionCollection (FieldDefinitionCollection fields);
		void VisitFieldDefinition (FieldDefinition field);
		void VisitPropertyDefinitionCollection (PropertyDefinitionCollection properties);
		void VisitPropertyDefinition (PropertyDefinition property);
		void VisitSecurityDeclarationCollection (SecurityDeclarationCollection secDecls);
		void VisitSecurityDeclaration (SecurityDeclaration secDecl);
		void VisitCustomAttributeCollection (CustomAttributeCollection customAttrs);
		void VisitCustomAttribute (CustomAttribute customAttr);
		void VisitGenericParameterCollection (GenericParameterCollection genparams);
		void VisitGenericParameter (GenericParameter genparam);
		void VisitMarshalSpec (MarshalDesc marshalSpec);

		void TerminateModuleDefinition (ModuleDefinition module);
	}
}
